Blame SOURCES/coreutils-8.32-split-number.patch

965c50
From bb0e7fabcaed9a7e71e30f05e638e9f243cdb13e Mon Sep 17 00:00:00 2001
965c50
From: =?UTF-8?q?P=C3=A1draig=20Brady?= <P@draigBrady.com>
965c50
Date: Mon, 25 Jan 2021 14:12:48 +0000
965c50
Subject: [PATCH] split: fix --number=K/N to output correct part of file
965c50
965c50
This functionality regressed with the adjustments
965c50
in commit v8.25-4-g62e7af032
965c50
965c50
* src/split.c (bytes_chunk_extract): Account for already read data
965c50
when seeking into the file.
965c50
* tests/split/b-chunk.sh: Use the hidden ---io-blksize option,
965c50
to test this functionality.
965c50
Fixes https://bugs.gnu.org/46048
965c50
965c50
Upstream-commit: bb21daa125aeb4e32546309d370918ca47e612db
965c50
Signed-off-by: Kamil Dudka <kdudka@redhat.com>
965c50
---
965c50
 src/split.c            |  2 +-
965c50
 tests/split/b-chunk.sh | 45 ++++++++++++++++++++++++------------------
965c50
 2 files changed, 27 insertions(+), 20 deletions(-)
965c50
965c50
diff --git a/src/split.c b/src/split.c
965c50
index 09e610b..19248f6 100644
965c50
--- a/src/split.c
965c50
+++ b/src/split.c
965c50
@@ -1001,7 +1001,7 @@ bytes_chunk_extract (uintmax_t k, uintmax_t n, char *buf, size_t bufsize,
965c50
     }
965c50
   else
965c50
     {
965c50
-      if (lseek (STDIN_FILENO, start, SEEK_CUR) < 0)
965c50
+      if (lseek (STDIN_FILENO, start - initial_read, SEEK_CUR) < 0)
965c50
         die (EXIT_FAILURE, errno, "%s", quotef (infile));
965c50
       initial_read = SIZE_MAX;
965c50
     }
965c50
diff --git a/tests/split/b-chunk.sh b/tests/split/b-chunk.sh
965c50
index 864ce55..39a6799 100755
965c50
--- a/tests/split/b-chunk.sh
965c50
+++ b/tests/split/b-chunk.sh
965c50
@@ -35,32 +35,39 @@ split -e -n 10 /dev/null || fail=1
965c50
 returns_ 1 stat x?? 2>/dev/null || fail=1
965c50
 
965c50
 printf '1\n2\n3\n4\n5\n' > input || framework_failure_
965c50
+printf '1\n2' > exp-1 || framework_failure_
965c50
+printf '\n3\n' > exp-2 || framework_failure_
965c50
+printf '4\n5\n' > exp-3 || framework_failure_
965c50
 
965c50
 for file in input /proc/version /sys/kernel/profiling; do
965c50
   test -f $file || continue
965c50
 
965c50
-  split -n 3 $file > out || fail=1
965c50
-  split -n 1/3 $file > b1 || fail=1
965c50
-  split -n 2/3 $file > b2 || fail=1
965c50
-  split -n 3/3 $file > b3 || fail=1
965c50
+  for blksize in 1 2 4096; do
965c50
+    if ! test "$file" = 'input'; then
965c50
+      # For /proc like files we must be able to read all
965c50
+      # into the internal buffer to be able to determine size.
965c50
+      test "$blksize" = 4096 || continue
965c50
+    fi
965c50
 
965c50
-  case $file in
965c50
-    input)
965c50
-      printf '1\n2' > exp-1
965c50
-      printf '\n3\n' > exp-2
965c50
-      printf '4\n5\n' > exp-3
965c50
+    split -n 3 ---io-blksize=$blksize $file > out || fail=1
965c50
+    split -n 1/3 ---io-blksize=$blksize $file > b1 || fail=1
965c50
+    split -n 2/3 ---io-blksize=$blksize $file > b2 || fail=1
965c50
+    split -n 3/3 ---io-blksize=$blksize $file > b3 || fail=1
965c50
 
965c50
-      compare exp-1 xaa || fail=1
965c50
-      compare exp-2 xab || fail=1
965c50
-      compare exp-3 xac || fail=1
965c50
-      ;;
965c50
-  esac
965c50
+    case $file in
965c50
+      input)
965c50
+        compare exp-1 xaa || fail=1
965c50
+        compare exp-2 xab || fail=1
965c50
+        compare exp-3 xac || fail=1
965c50
+        ;;
965c50
+    esac
965c50
 
965c50
-  compare xaa b1 || fail=1
965c50
-  compare xab b2 || fail=1
965c50
-  compare xac b3 || fail=1
965c50
-  cat xaa xab xac | compare - $file || fail=1
965c50
-  test -f xad && fail=1
965c50
+    compare xaa b1 || fail=1
965c50
+    compare xab b2 || fail=1
965c50
+    compare xac b3 || fail=1
965c50
+    cat xaa xab xac | compare - $file || fail=1
965c50
+    test -f xad && fail=1
965c50
+  done
965c50
 done
965c50
 
965c50
 Exit $fail
965c50
-- 
965c50
2.26.2
965c50